#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TorqueStructArgumentsInfo GetArgumentsFrameAndCount_0(compiler::CodeAssemblerState* state_, TNode<Context> p_context, TNode<JSFunction> p_f) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT> block5(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT> block4(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT, SharedFunctionInfo, BInt, BInt, RawPtrT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT, SharedFunctionInfo, BInt, BInt, RawPtrT, RawPtrT> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT, SharedFunctionInfo, BInt, BInt> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT, SharedFunctionInfo, BInt, BInt, RawPtrT> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT, BInt, BInt> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSFunction, RawPtrT, BInt, BInt> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, p_context, p_f);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSFunction> tmp1;
    ca_.Bind(&block0, &tmp0, &tmp1);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 37);
    TNode<RawPtrT> tmp2;
    USE(tmp2);
    tmp2 = CodeStubAssembler(state_).LoadParentFramePointer();
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 38);
    ca_.Goto(&block3, tmp0, tmp1, tmp2);
  }

  if (block2.is_used()) {
    TNode<Context> tmp3;
    TNode<JSFunction> tmp4;
    TNode<RawPtrT> tmp5;
    ca_.Bind(&block2, &tmp3, &tmp4, &tmp5);
    TNode<JSFunction> tmp6;
    USE(tmp6);
    tmp6 = LoadFunctionFromFrame_299(state_, TNode<RawPtrT>{tmp5});
    TNode<BoolT> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).TaggedEqual(TNode<HeapObject>{tmp6}, TNode<HeapObject>{tmp4});
    ca_.Branch(tmp7, &block4, &block5, tmp3, tmp4, tmp5);
  }

  if (block5.is_used()) {
    TNode<Context> tmp8;
    TNode<JSFunction> tmp9;
    TNode<RawPtrT> tmp10;
    ca_.Bind(&block5, &tmp8, &tmp9, &tmp10);
    CodeStubAssembler(state_).FailAssert("Torque assert 'frame.function == f' failed", "../../deps/v8/src/builtins/arguments.tq", 38);
  }

  if (block4.is_used()) {
    TNode<Context> tmp11;
    TNode<JSFunction> tmp12;
    TNode<RawPtrT> tmp13;
    ca_.Bind(&block4, &tmp11, &tmp12, &tmp13);
  }

  if (block3.is_used()) {
    TNode<Context> tmp14;
    TNode<JSFunction> tmp15;
    TNode<RawPtrT> tmp16;
    ca_.Bind(&block3, &tmp14, &tmp15, &tmp16);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 40);
    TNode<IntPtrT> tmp17 = ca_.IntPtrConstant(JSFunction::kSharedFunctionInfoOffset);
    USE(tmp17);
    TNode<SharedFunctionInfo>tmp18 = CodeStubAssembler(state_).LoadReference<SharedFunctionInfo>(CodeStubAssembler::Reference{tmp15, tmp17});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 42);
    TNode<IntPtrT> tmp19 = ca_.IntPtrConstant(SharedFunctionInfo::kFormalParameterCountOffset);
    USE(tmp19);
    TNode<Uint16T>tmp20 = CodeStubAssembler(state_).LoadReference<Uint16T>(CodeStubAssembler::Reference{tmp18, tmp19});
    TNode<Int32T> tmp21;
    USE(tmp21);
    tmp21 = Convert7ATint328ATuint16_184(state_, TNode<Uint16T>{tmp20});
    TNode<BInt> tmp22;
    USE(tmp22);
    tmp22 = Convert6ATbint7ATint32_209(state_, TNode<Int32T>{tmp21});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 41);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 43);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 46);
    TNode<RawPtrT> tmp23;
    USE(tmp23);
    tmp23 = LoadCallerFromFrame_300(state_, TNode<RawPtrT>{tmp16});
    TNode<RawPtrT> tmp24;
    USE(tmp24);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp24 = Cast23ATArgumentsAdaptorFrame_306(state_, TNode<Context>{tmp14}, TNode<RawPtrT>{tmp23}, &label0);
    ca_.Goto(&block8, tmp14, tmp15, tmp16, tmp18, tmp22, tmp22, tmp23, tmp24);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block9, tmp14, tmp15, tmp16, tmp18, tmp22, tmp22, tmp23);
    }
  }

  if (block9.is_used()) {
    TNode<Context> tmp25;
    TNode<JSFunction> tmp26;
    TNode<RawPtrT> tmp27;
    TNode<SharedFunctionInfo> tmp28;
    TNode<BInt> tmp29;
    TNode<BInt> tmp30;
    TNode<RawPtrT> tmp31;
    ca_.Bind(&block9, &tmp25, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30, &tmp31);
    ca_.Goto(&block7, tmp25, tmp26, tmp27, tmp28, tmp29, tmp30);
  }

  if (block8.is_used()) {
    TNode<Context> tmp32;
    TNode<JSFunction> tmp33;
    TNode<RawPtrT> tmp34;
    TNode<SharedFunctionInfo> tmp35;
    TNode<BInt> tmp36;
    TNode<BInt> tmp37;
    TNode<RawPtrT> tmp38;
    TNode<RawPtrT> tmp39;
    ca_.Bind(&block8, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38, &tmp39);
    ca_.Goto(&block6, tmp32, tmp33, tmp34, tmp35, tmp36, tmp37, tmp39);
  }

  if (block7.is_used()) {
    TNode<Context> tmp40;
    TNode<JSFunction> tmp41;
    TNode<RawPtrT> tmp42;
    TNode<SharedFunctionInfo> tmp43;
    TNode<BInt> tmp44;
    TNode<BInt> tmp45;
    ca_.Bind(&block7, &tmp40, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 48);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 49);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 50);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 47);
    ca_.Goto(&block1, tmp40, tmp41, tmp42, tmp45, tmp44);
  }

  if (block6.is_used()) {
    TNode<Context> tmp46;
    TNode<JSFunction> tmp47;
    TNode<RawPtrT> tmp48;
    TNode<SharedFunctionInfo> tmp49;
    TNode<BInt> tmp50;
    TNode<BInt> tmp51;
    TNode<RawPtrT> tmp52;
    ca_.Bind(&block6, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51, &tmp52);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 45);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 54);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 55);
    TNode<Smi> tmp53;
    USE(tmp53);
    tmp53 = LoadLengthFromAdapterFrame_303(state_, TNode<Context>{tmp46}, TNode<RawPtrT>{tmp52});
    TNode<BInt> tmp54;
    USE(tmp54);
    tmp54 = Convert6ATbint5ATSmi_211(state_, TNode<Smi>{tmp53});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 56);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 53);
    ca_.Goto(&block1, tmp46, tmp47, tmp52, tmp54, tmp50);
  }

  if (block1.is_used()) {
    TNode<Context> tmp55;
    TNode<JSFunction> tmp56;
    TNode<RawPtrT> tmp57;
    TNode<BInt> tmp58;
    TNode<BInt> tmp59;
    ca_.Bind(&block1, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/arguments.tq", 34);
    ca_.Goto(&block10, tmp55, tmp56, tmp57, tmp58, tmp59);
  }

    TNode<Context> tmp60;
    TNode<JSFunction> tmp61;
    TNode<RawPtrT> tmp62;
    TNode<BInt> tmp63;
    TNode<BInt> tmp64;
    ca_.Bind(&block10, &tmp60, &tmp61, &tmp62, &tmp63, &tmp64);
  return TorqueStructArgumentsInfo{TNode<RawPtrT>{tmp62}, TNode<BInt>{tmp63}, TNode<BInt>{tmp64}};
}

}  // namespace internal
}  // namespace v8

