#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

TF_BUILTIN(ProxyGetProperty, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<JSProxy> parameter1 = UncheckedCast<JSProxy>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<Name> parameter2 = UncheckedCast<Name>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  TNode<Object> parameter3 = UncheckedCast<Object>(Parameter(Descriptor::ParameterIndex<2>()));
  USE(parameter3);
  TNode<Smi> parameter4 = UncheckedCast<Smi>(Parameter(Descriptor::ParameterIndex<3>()));
  USE(parameter4);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block8(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block12(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, HeapObject, HeapObject> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, HeapObject, HeapObject, Oddball> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, HeapObject> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, HeapObject> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, HeapObject> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, HeapObject, JSReceiver> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, JSReceiver> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, JSReceiver, JSReceiver> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, JSReceiver, JSReceiver, JSReceiver> block23(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, JSReceiver> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, JSProxy, Name, Object, Smi, JSReceiver, JSReceiver, JSReceiver> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2, parameter3, parameter4);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<JSProxy> tmp1;
    TNode<Name> tmp2;
    TNode<Object> tmp3;
    TNode<Smi> tmp4;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2, &tmp3, &tmp4);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 18);
    CodeStubAssembler(state_).PerformStackCheck(TNode<Context>{tmp0});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 20);
    ca_.Goto(&block2, tmp0, tmp1, tmp2, tmp3, tmp4);
  }

  if (block1.is_used()) {
    TNode<Context> tmp5;
    TNode<JSProxy> tmp6;
    TNode<Name> tmp7;
    TNode<Object> tmp8;
    TNode<Smi> tmp9;
    ca_.Bind(&block1, &tmp5, &tmp6, &tmp7, &tmp8, &tmp9);
    TNode<BoolT> tmp10;
    USE(tmp10);
    tmp10 = CodeStubAssembler(state_).TaggedIsNotSmi(TNode<Object>{tmp7});
    ca_.Branch(tmp10, &block3, &block4, tmp5, tmp6, tmp7, tmp8, tmp9);
  }

  if (block4.is_used()) {
    TNode<Context> tmp11;
    TNode<JSProxy> tmp12;
    TNode<Name> tmp13;
    TNode<Object> tmp14;
    TNode<Smi> tmp15;
    ca_.Bind(&block4, &tmp11, &tmp12, &tmp13, &tmp14, &tmp15);
    CodeStubAssembler(state_).FailAssert("Torque assert 'TaggedIsNotSmi(name)' failed", "../../deps/v8/src/builtins/proxy-get-property.tq", 20);
  }

  if (block3.is_used()) {
    TNode<Context> tmp16;
    TNode<JSProxy> tmp17;
    TNode<Name> tmp18;
    TNode<Object> tmp19;
    TNode<Smi> tmp20;
    ca_.Bind(&block3, &tmp16, &tmp17, &tmp18, &tmp19, &tmp20);
  }

  if (block2.is_used()) {
    TNode<Context> tmp21;
    TNode<JSProxy> tmp22;
    TNode<Name> tmp23;
    TNode<Object> tmp24;
    TNode<Smi> tmp25;
    ca_.Bind(&block2, &tmp21, &tmp22, &tmp23, &tmp24, &tmp25);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 21);
    ca_.Goto(&block6, tmp21, tmp22, tmp23, tmp24, tmp25);
  }

  if (block5.is_used()) {
    TNode<Context> tmp26;
    TNode<JSProxy> tmp27;
    TNode<Name> tmp28;
    TNode<Object> tmp29;
    TNode<Smi> tmp30;
    ca_.Bind(&block5, &tmp26, &tmp27, &tmp28, &tmp29, &tmp30);
    TNode<BoolT> tmp31;
    USE(tmp31);
    tmp31 = CodeStubAssembler(state_).IsName(TNode<HeapObject>{tmp28});
    ca_.Branch(tmp31, &block7, &block8, tmp26, tmp27, tmp28, tmp29, tmp30);
  }

  if (block8.is_used()) {
    TNode<Context> tmp32;
    TNode<JSProxy> tmp33;
    TNode<Name> tmp34;
    TNode<Object> tmp35;
    TNode<Smi> tmp36;
    ca_.Bind(&block8, &tmp32, &tmp33, &tmp34, &tmp35, &tmp36);
    CodeStubAssembler(state_).FailAssert("Torque assert 'IsName(name)' failed", "../../deps/v8/src/builtins/proxy-get-property.tq", 21);
  }

  if (block7.is_used()) {
    TNode<Context> tmp37;
    TNode<JSProxy> tmp38;
    TNode<Name> tmp39;
    TNode<Object> tmp40;
    TNode<Smi> tmp41;
    ca_.Bind(&block7, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41);
  }

  if (block6.is_used()) {
    TNode<Context> tmp42;
    TNode<JSProxy> tmp43;
    TNode<Name> tmp44;
    TNode<Object> tmp45;
    TNode<Smi> tmp46;
    ca_.Bind(&block6, &tmp42, &tmp43, &tmp44, &tmp45, &tmp46);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 22);
    ca_.Goto(&block10, tmp42, tmp43, tmp44, tmp45, tmp46);
  }

  if (block9.is_used()) {
    TNode<Context> tmp47;
    TNode<JSProxy> tmp48;
    TNode<Name> tmp49;
    TNode<Object> tmp50;
    TNode<Smi> tmp51;
    ca_.Bind(&block9, &tmp47, &tmp48, &tmp49, &tmp50, &tmp51);
    TNode<BoolT> tmp52;
    USE(tmp52);
    tmp52 = CodeStubAssembler(state_).IsPrivateSymbol(TNode<HeapObject>{tmp49});
    TNode<BoolT> tmp53;
    USE(tmp53);
    tmp53 = CodeStubAssembler(state_).Word32BinaryNot(TNode<BoolT>{tmp52});
    ca_.Branch(tmp53, &block11, &block12, tmp47, tmp48, tmp49, tmp50, tmp51);
  }

  if (block12.is_used()) {
    TNode<Context> tmp54;
    TNode<JSProxy> tmp55;
    TNode<Name> tmp56;
    TNode<Object> tmp57;
    TNode<Smi> tmp58;
    ca_.Bind(&block12, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58);
    CodeStubAssembler(state_).FailAssert("Torque assert '!IsPrivateSymbol(name)' failed", "../../deps/v8/src/builtins/proxy-get-property.tq", 22);
  }

  if (block11.is_used()) {
    TNode<Context> tmp59;
    TNode<JSProxy> tmp60;
    TNode<Name> tmp61;
    TNode<Object> tmp62;
    TNode<Smi> tmp63;
    ca_.Bind(&block11, &tmp59, &tmp60, &tmp61, &tmp62, &tmp63);
  }

  if (block10.is_used()) {
    TNode<Context> tmp64;
    TNode<JSProxy> tmp65;
    TNode<Name> tmp66;
    TNode<Object> tmp67;
    TNode<Smi> tmp68;
    ca_.Bind(&block10, &tmp64, &tmp65, &tmp66, &tmp67, &tmp68);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 27);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 28);
    TNode<IntPtrT> tmp69 = ca_.IntPtrConstant(JSProxy::kHandlerOffset);
    USE(tmp69);
    TNode<HeapObject>tmp70 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp65, tmp69});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 29);
    TNode<Oddball> tmp71;
    USE(tmp71);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp71 = Cast6ATNull_101(state_, TNode<HeapObject>{tmp70}, &label0);
    ca_.Goto(&block15, tmp64, tmp65, tmp66, tmp67, tmp68, ca_.Uninitialized<JSReceiver>(), tmp70, tmp70, tmp71);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block16, tmp64, tmp65, tmp66, tmp67, tmp68, ca_.Uninitialized<JSReceiver>(), tmp70, tmp70);
    }
  }

  if (block16.is_used()) {
    TNode<Context> tmp72;
    TNode<JSProxy> tmp73;
    TNode<Name> tmp74;
    TNode<Object> tmp75;
    TNode<Smi> tmp76;
    TNode<JSReceiver> tmp77;
    TNode<HeapObject> tmp78;
    TNode<HeapObject> tmp79;
    ca_.Bind(&block16, &tmp72, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78, &tmp79);
    ca_.Goto(&block14, tmp72, tmp73, tmp74, tmp75, tmp76, tmp77, tmp78);
  }

  if (block15.is_used()) {
    TNode<Context> tmp80;
    TNode<JSProxy> tmp81;
    TNode<Name> tmp82;
    TNode<Object> tmp83;
    TNode<Smi> tmp84;
    TNode<JSReceiver> tmp85;
    TNode<HeapObject> tmp86;
    TNode<HeapObject> tmp87;
    TNode<Oddball> tmp88;
    ca_.Bind(&block15, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87, &tmp88);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 30);
    CodeStubAssembler(state_).ThrowTypeError(TNode<Context>{tmp80}, MessageTemplate::kProxyRevoked, "get");
  }

  if (block14.is_used()) {
    TNode<Context> tmp89;
    TNode<JSProxy> tmp90;
    TNode<Name> tmp91;
    TNode<Object> tmp92;
    TNode<Smi> tmp93;
    TNode<JSReceiver> tmp94;
    TNode<HeapObject> tmp95;
    ca_.Bind(&block14, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93, &tmp94, &tmp95);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 32);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 33);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 29);
    ca_.Goto(&block13, tmp89, tmp90, tmp91, tmp92, tmp93, ca_.UncheckedCast<JSReceiver>(tmp95), tmp95);
  }

  if (block13.is_used()) {
    TNode<Context> tmp96;
    TNode<JSProxy> tmp97;
    TNode<Name> tmp98;
    TNode<Object> tmp99;
    TNode<Smi> tmp100;
    TNode<JSReceiver> tmp101;
    TNode<HeapObject> tmp102;
    ca_.Bind(&block13, &tmp96, &tmp97, &tmp98, &tmp99, &tmp100, &tmp101, &tmp102);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 28);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 38);
    TNode<IntPtrT> tmp103 = ca_.IntPtrConstant(JSProxy::kTargetOffset);
    USE(tmp103);
    TNode<HeapObject>tmp104 = CodeStubAssembler(state_).LoadReference<HeapObject>(CodeStubAssembler::Reference{tmp97, tmp103});
    TNode<JSReceiver> tmp105;
    USE(tmp105);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp105 = Cast10JSReceiver_143(state_, TNode<HeapObject>{tmp104}, &label0);
    ca_.Goto(&block19, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp104, tmp105);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block20, tmp96, tmp97, tmp98, tmp99, tmp100, tmp101, tmp104);
    }
  }

  if (block20.is_used()) {
    TNode<Context> tmp106;
    TNode<JSProxy> tmp107;
    TNode<Name> tmp108;
    TNode<Object> tmp109;
    TNode<Smi> tmp110;
    TNode<JSReceiver> tmp111;
    TNode<HeapObject> tmp112;
    ca_.Bind(&block20, &tmp106, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111, &tmp112);
    ca_.Goto(&block18, tmp106, tmp107, tmp108, tmp109, tmp110, tmp111);
  }

  if (block19.is_used()) {
    TNode<Context> tmp113;
    TNode<JSProxy> tmp114;
    TNode<Name> tmp115;
    TNode<Object> tmp116;
    TNode<Smi> tmp117;
    TNode<JSReceiver> tmp118;
    TNode<HeapObject> tmp119;
    TNode<JSReceiver> tmp120;
    ca_.Bind(&block19, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118, &tmp119, &tmp120);
    ca_.Goto(&block17, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp120);
  }

  if (block18.is_used()) {
    TNode<Context> tmp121;
    TNode<JSProxy> tmp122;
    TNode<Name> tmp123;
    TNode<Object> tmp124;
    TNode<Smi> tmp125;
    TNode<JSReceiver> tmp126;
    ca_.Bind(&block18, &tmp121, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126);
    CodeStubAssembler(state_).Unreachable();
  }

  if (block17.is_used()) {
    TNode<Context> tmp127;
    TNode<JSProxy> tmp128;
    TNode<Name> tmp129;
    TNode<Object> tmp130;
    TNode<Smi> tmp131;
    TNode<JSReceiver> tmp132;
    TNode<JSReceiver> tmp133;
    ca_.Bind(&block17, &tmp127, &tmp128, &tmp129, &tmp130, &tmp131, &tmp132, &tmp133);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 43);
    TNode<JSReceiver> tmp134;
    USE(tmp134);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp134 = GetMethod_248(state_, TNode<Context>{tmp127}, TNode<Object>{tmp132}, "get", &label0);
    ca_.Goto(&block23, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp133, tmp132, tmp134);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block24, tmp127, tmp128, tmp129, tmp130, tmp131, tmp132, tmp133, tmp132);
    }
  }

  if (block24.is_used()) {
    TNode<Context> tmp135;
    TNode<JSProxy> tmp136;
    TNode<Name> tmp137;
    TNode<Object> tmp138;
    TNode<Smi> tmp139;
    TNode<JSReceiver> tmp140;
    TNode<JSReceiver> tmp141;
    TNode<JSReceiver> tmp142;
    ca_.Bind(&block24, &tmp135, &tmp136, &tmp137, &tmp138, &tmp139, &tmp140, &tmp141, &tmp142);
    ca_.Goto(&block22, tmp135, tmp136, tmp137, tmp138, tmp139, tmp140, tmp141);
  }

  if (block23.is_used()) {
    TNode<Context> tmp143;
    TNode<JSProxy> tmp144;
    TNode<Name> tmp145;
    TNode<Object> tmp146;
    TNode<Smi> tmp147;
    TNode<JSReceiver> tmp148;
    TNode<JSReceiver> tmp149;
    TNode<JSReceiver> tmp150;
    TNode<JSReceiver> tmp151;
    ca_.Bind(&block23, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149, &tmp150, &tmp151);
    ca_.Goto(&block21, tmp143, tmp144, tmp145, tmp146, tmp147, tmp148, tmp149, tmp151);
  }

  if (block22.is_used()) {
    TNode<Context> tmp152;
    TNode<JSProxy> tmp153;
    TNode<Name> tmp154;
    TNode<Object> tmp155;
    TNode<Smi> tmp156;
    TNode<JSReceiver> tmp157;
    TNode<JSReceiver> tmp158;
    ca_.Bind(&block22, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156, &tmp157, &tmp158);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 45);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 44);
    TNode<Object> tmp159;
    tmp159 = CodeStubAssembler(state_).CallBuiltin(Builtins::kGetPropertyWithReceiver, tmp152, tmp158, tmp154, tmp155, tmp156);
    USE(tmp159);
    CodeStubAssembler(state_).Return(tmp159);
  }

  if (block21.is_used()) {
    TNode<Context> tmp160;
    TNode<JSProxy> tmp161;
    TNode<Name> tmp162;
    TNode<Object> tmp163;
    TNode<Smi> tmp164;
    TNode<JSReceiver> tmp165;
    TNode<JSReceiver> tmp166;
    TNode<JSReceiver> tmp167;
    ca_.Bind(&block21, &tmp160, &tmp161, &tmp162, &tmp163, &tmp164, &tmp165, &tmp166, &tmp167);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 43);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 49);
    TNode<Object> tmp168;
    USE(tmp168);
    tmp168 = CodeStubAssembler(state_).Call(TNode<Context>{tmp160}, TNode<JSReceiver>{tmp167}, TNode<Object>{tmp165}, TNode<Object>{tmp166}, TNode<Object>{tmp162}, TNode<Object>{tmp163});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 62);
    ProxiesCodeStubAssembler(state_).CheckGetSetTrapResult(TNode<Context>{tmp160}, TNode<JSReceiver>{tmp166}, TNode<JSProxy>{tmp161}, TNode<Name>{tmp162}, TNode<Object>{tmp168}, JSProxy::AccessKind::kGet);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/proxy-get-property.tq", 63);
    CodeStubAssembler(state_).Return(tmp168);
  }
}

}  // namespace internal
}  // namespace v8

