#include "src/builtins/builtins-array-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-utils-gen.h"
#include "src/builtins/builtins.h"
#include "src/codegen/code-factory.h"
#include "src/heap/factory-inl.h"
#include "src/objects/arguments.h"
#include "src/objects/bigint.h"
#include "src/objects/elements-kind.h"
#include "src/objects/free-space.h"
#include "src/objects/js-generator.h"
#include "src/objects/js-promise.h"
#include "src/objects/js-regexp-string-iterator.h"
#include "src/objects/js-weak-refs.h"
#include "src/objects/objects.h"
#include "src/objects/source-text-module.h"
#include "src/objects/stack-frame-info.h"
#include "src/objects/synthetic-module.h"
#include "src/objects/template-objects.h"
#include "src/builtins/builtins-bigint-gen.h"
#include "src/builtins/builtins-collections-gen.h"
#include "src/builtins/builtins-data-view-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-iterator-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-proxy-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-string-gen.h"
#include "src/builtins/builtins-regexp-gen.h"
#include "src/builtins/builtins-constructor-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/builtins/builtins-typed-array-gen.h"
#include "src/objects/js-break-iterator.h"
#include "src/objects/js-collator.h"
#include "src/objects/js-number-format.h"
#include "src/objects/js-objects.h"
#include "src/objects/js-plural-rules.h"
#include "src/objects/js-relative-time-format.h"
#include "src/objects/js-date-time-format.h"
#include "src/objects/js-list-format.h"
#include "src/objects/js-locale.h"
#include "src/objects/js-segment-iterator.h"
#include "src/objects/js-segmenter.h"
#include "torque-generated/../../deps/v8/src/builtins/arguments-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-copywithin-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-join-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-lastindexof-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-map-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-right-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-reverse-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-shift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-splice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-unshift-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/base-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/bigint-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/boolean-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/collections-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/data-view-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/extras-utils-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/frames-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/growable-fixed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/internal-coverage-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/math-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-fromentries-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/object-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-constructor-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-delete-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-get-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-has-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-is-extensible-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-prevent-extensions-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revocable-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-revoke-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-property-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-set-prototype-of-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/proxy-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/reflect-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-exec-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-all-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-match-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-replace-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-search-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-source-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-split-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-test-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/regexp-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-endswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-html-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-iterator-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-pad-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-repeat-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-startswith-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/string-substring-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/torque-internal-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-createtypedarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-every-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-filter-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-find-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-findindex-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-foreach-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduce-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-reduceright-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-slice-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-some-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-subarray-tq-csa.h"
#include "torque-generated/../../deps/v8/src/builtins/typed-array-tq-csa.h"
#include "torque-generated/../../deps/v8/third_party/v8/builtins/array-sort-tq-csa.h"
#include "torque-generated/../../deps/v8/test/torque/test-torque-tq-csa.h"
#include "torque-generated/../../deps/v8/src/objects/intl-objects-tq-csa.h"

namespace v8 {
namespace internal {

const char* kBuiltinName_352(compiler::CodeAssemblerState* state_) {
  compiler::CodeAssembler ca_(state_);
  compiler::CodeAssemblerParameterizedLabel<> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0);

    ca_.Bind(&block0);
return "String.prototype.repeat";
}

TF_BUILTIN(StringRepeat, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<String> parameter1 = UncheckedCast<String>(Parameter(Descriptor::ParameterIndex<0>()));
  USE(parameter1);
  TNode<Smi> parameter2 = UncheckedCast<Smi>(Parameter(Descriptor::ParameterIndex<1>()));
  USE(parameter2);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block1(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block4(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block3(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block2(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block5(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block8(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block7(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi, String, String, IntPtrT> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi, String, String, IntPtrT> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi, String, String, IntPtrT> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi, String, String, IntPtrT> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi, String, String, IntPtrT> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi, String, String, IntPtrT> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, String, Smi, String, String, IntPtrT> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<String> tmp1;
    TNode<Smi> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 10);
    ca_.Goto(&block2, tmp0, tmp1, tmp2);
  }

  if (block1.is_used()) {
    TNode<Context> tmp3;
    TNode<String> tmp4;
    TNode<Smi> tmp5;
    ca_.Bind(&block1, &tmp3, &tmp4, &tmp5);
    TNode<Smi> tmp6;
    USE(tmp6);
    tmp6 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 0);
    TNode<BoolT> tmp7;
    USE(tmp7);
    tmp7 = CodeStubAssembler(state_).SmiGreaterThanOrEqual(TNode<Smi>{tmp5}, TNode<Smi>{tmp6});
    ca_.Branch(tmp7, &block3, &block4, tmp3, tmp4, tmp5);
  }

  if (block4.is_used()) {
    TNode<Context> tmp8;
    TNode<String> tmp9;
    TNode<Smi> tmp10;
    ca_.Bind(&block4, &tmp8, &tmp9, &tmp10);
    CodeStubAssembler(state_).FailAssert("Torque assert 'count >= 0' failed", "../../deps/v8/src/builtins/string-repeat.tq", 10);
  }

  if (block3.is_used()) {
    TNode<Context> tmp11;
    TNode<String> tmp12;
    TNode<Smi> tmp13;
    ca_.Bind(&block3, &tmp11, &tmp12, &tmp13);
  }

  if (block2.is_used()) {
    TNode<Context> tmp14;
    TNode<String> tmp15;
    TNode<Smi> tmp16;
    ca_.Bind(&block2, &tmp14, &tmp15, &tmp16);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 11);
    ca_.Goto(&block6, tmp14, tmp15, tmp16);
  }

  if (block5.is_used()) {
    TNode<Context> tmp17;
    TNode<String> tmp18;
    TNode<Smi> tmp19;
    ca_.Bind(&block5, &tmp17, &tmp18, &tmp19);
    TNode<String> tmp20;
    USE(tmp20);
    tmp20 = kEmptyString_67(state_);
    TNode<BoolT> tmp21;
    USE(tmp21);
    tmp21 = CodeStubAssembler(state_).TaggedNotEqual(TNode<Object>{tmp18}, TNode<HeapObject>{tmp20});
    ca_.Branch(tmp21, &block7, &block8, tmp17, tmp18, tmp19);
  }

  if (block8.is_used()) {
    TNode<Context> tmp22;
    TNode<String> tmp23;
    TNode<Smi> tmp24;
    ca_.Bind(&block8, &tmp22, &tmp23, &tmp24);
    CodeStubAssembler(state_).FailAssert("Torque assert 'string != kEmptyString' failed", "../../deps/v8/src/builtins/string-repeat.tq", 11);
  }

  if (block7.is_used()) {
    TNode<Context> tmp25;
    TNode<String> tmp26;
    TNode<Smi> tmp27;
    ca_.Bind(&block7, &tmp25, &tmp26, &tmp27);
  }

  if (block6.is_used()) {
    TNode<Context> tmp28;
    TNode<String> tmp29;
    TNode<Smi> tmp30;
    ca_.Bind(&block6, &tmp28, &tmp29, &tmp30);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 13);
    TNode<String> tmp31;
    USE(tmp31);
    tmp31 = kEmptyString_67(state_);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 14);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 15);
    TNode<IntPtrT> tmp32;
    USE(tmp32);
    tmp32 = Convert8ATintptr5ATSmi_189(state_, TNode<Smi>{tmp30});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 17);
    ca_.Goto(&block11, tmp28, tmp29, tmp30, tmp31, tmp29, tmp32);
  }

  if (block11.is_used()) {
    TNode<Context> tmp33;
    TNode<String> tmp34;
    TNode<Smi> tmp35;
    TNode<String> tmp36;
    TNode<String> tmp37;
    TNode<IntPtrT> tmp38;
    ca_.Bind(&block11, &tmp33, &tmp34, &tmp35, &tmp36, &tmp37, &tmp38);
    TNode<BoolT> tmp39;
    USE(tmp39);
    tmp39 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Branch(tmp39, &block9, &block10, tmp33, tmp34, tmp35, tmp36, tmp37, tmp38);
  }

  if (block9.is_used()) {
    TNode<Context> tmp40;
    TNode<String> tmp41;
    TNode<Smi> tmp42;
    TNode<String> tmp43;
    TNode<String> tmp44;
    TNode<IntPtrT> tmp45;
    ca_.Bind(&block9, &tmp40, &tmp41, &tmp42, &tmp43, &tmp44, &tmp45);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 18);
    TNode<IntPtrT> tmp46;
    USE(tmp46);
    tmp46 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    TNode<IntPtrT> tmp47;
    USE(tmp47);
    tmp47 = CodeStubAssembler(state_).WordAnd(TNode<IntPtrT>{tmp45}, TNode<IntPtrT>{tmp46});
    TNode<IntPtrT> tmp48;
    USE(tmp48);
    tmp48 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    TNode<BoolT> tmp49;
    USE(tmp49);
    tmp49 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp47}, TNode<IntPtrT>{tmp48});
    ca_.Branch(tmp49, &block12, &block13, tmp40, tmp41, tmp42, tmp43, tmp44, tmp45);
  }

  if (block12.is_used()) {
    TNode<Context> tmp50;
    TNode<String> tmp51;
    TNode<Smi> tmp52;
    TNode<String> tmp53;
    TNode<String> tmp54;
    TNode<IntPtrT> tmp55;
    ca_.Bind(&block12, &tmp50, &tmp51, &tmp52, &tmp53, &tmp54, &tmp55);
    TNode<String> tmp56;
    USE(tmp56);
    tmp56 = StringAdd_82(state_, TNode<Context>{tmp50}, TNode<String>{tmp53}, TNode<String>{tmp54});
    ca_.Goto(&block13, tmp50, tmp51, tmp52, tmp56, tmp54, tmp55);
  }

  if (block13.is_used()) {
    TNode<Context> tmp57;
    TNode<String> tmp58;
    TNode<Smi> tmp59;
    TNode<String> tmp60;
    TNode<String> tmp61;
    TNode<IntPtrT> tmp62;
    ca_.Bind(&block13, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61, &tmp62);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 20);
    TNode<IntPtrT> tmp63;
    USE(tmp63);
    tmp63 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 1);
    TNode<IntPtrT> tmp64;
    USE(tmp64);
    tmp64 = CodeStubAssembler(state_).WordSar(TNode<IntPtrT>{tmp62}, TNode<IntPtrT>{tmp63});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 21);
    TNode<IntPtrT> tmp65;
    USE(tmp65);
    tmp65 = FromConstexpr8ATintptr17ATconstexpr_int31_151(state_, 0);
    TNode<BoolT> tmp66;
    USE(tmp66);
    tmp66 = CodeStubAssembler(state_).WordEqual(TNode<IntPtrT>{tmp64}, TNode<IntPtrT>{tmp65});
    ca_.Branch(tmp66, &block14, &block15, tmp57, tmp58, tmp59, tmp60, tmp61, tmp64);
  }

  if (block14.is_used()) {
    TNode<Context> tmp67;
    TNode<String> tmp68;
    TNode<Smi> tmp69;
    TNode<String> tmp70;
    TNode<String> tmp71;
    TNode<IntPtrT> tmp72;
    ca_.Bind(&block14, &tmp67, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72);
    ca_.Goto(&block10, tmp67, tmp68, tmp69, tmp70, tmp71, tmp72);
  }

  if (block15.is_used()) {
    TNode<Context> tmp73;
    TNode<String> tmp74;
    TNode<Smi> tmp75;
    TNode<String> tmp76;
    TNode<String> tmp77;
    TNode<IntPtrT> tmp78;
    ca_.Bind(&block15, &tmp73, &tmp74, &tmp75, &tmp76, &tmp77, &tmp78);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 23);
    TNode<String> tmp79;
    USE(tmp79);
    tmp79 = StringAdd_82(state_, TNode<Context>{tmp73}, TNode<String>{tmp77}, TNode<String>{tmp77});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 17);
    ca_.Goto(&block11, tmp73, tmp74, tmp75, tmp76, tmp79, tmp78);
  }

  if (block10.is_used()) {
    TNode<Context> tmp80;
    TNode<String> tmp81;
    TNode<Smi> tmp82;
    TNode<String> tmp83;
    TNode<String> tmp84;
    TNode<IntPtrT> tmp85;
    ca_.Bind(&block10, &tmp80, &tmp81, &tmp82, &tmp83, &tmp84, &tmp85);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 26);
    CodeStubAssembler(state_).Return(tmp83);
  }
}

TF_BUILTIN(StringPrototypeRepeat, CodeStubAssembler) {
  compiler::CodeAssemblerState* state_ = state();  compiler::CodeAssembler ca_(state());
  TNode<Context> parameter0 = UncheckedCast<Context>(Parameter(Descriptor::kContext));
  USE(parameter0);
  TNode<Object> parameter1 = UncheckedCast<Object>(Parameter(Descriptor::kReceiver));
USE(parameter1);
  TNode<Object> parameter2 = UncheckedCast<Object>(Parameter(Descriptor::kCount));
  USE(parameter2);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object> block0(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Number> block10(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Number, Smi> block9(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi> block11(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi> block12(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi, BoolT> block15(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi, BoolT> block16(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi, BoolT, BoolT> block17(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi> block13(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi> block14(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi> block18(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, Smi> block19(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number> block8(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber> block20(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber> block23(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber> block22(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber> block21(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber, Float64T, BoolT> block26(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber, Float64T, BoolT> block27(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber, Float64T, BoolT, BoolT> block28(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber, Float64T> block24(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber, Float64T> block25(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber, Float64T> block29(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String, Number, HeapNumber, Float64T> block30(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String> block6(&ca_, compiler::CodeAssemblerLabel::kNonDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String> block4(&ca_, compiler::CodeAssemblerLabel::kDeferred);
  compiler::CodeAssemblerParameterizedLabel<Context, Object, Object, String> block2(&ca_, compiler::CodeAssemblerLabel::kDeferred);
    ca_.Goto(&block0, parameter0, parameter1, parameter2);

  if (block0.is_used()) {
    TNode<Context> tmp0;
    TNode<Object> tmp1;
    TNode<Object> tmp2;
    ca_.Bind(&block0, &tmp0, &tmp1, &tmp2);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 34);
    TNode<String> tmp3;
    USE(tmp3);
    tmp3 = FromConstexpr6String18ATconstexpr_string_157(state_, kBuiltinName_352(state_));
    TNode<String> tmp4;
    USE(tmp4);
    tmp4 = CodeStubAssembler(state_).ToThisString(TNode<Context>{tmp0}, TNode<Object>{tmp1}, TNode<String>{tmp3});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 38);
    TNode<Number> tmp5;
    USE(tmp5);
    tmp5 = CodeStubAssembler(state_).ToInteger_Inline(TNode<Context>{tmp0}, TNode<Object>{tmp2}, CodeStubAssembler::ToIntegerTruncationMode::kTruncateMinusZero);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 39);
    TNode<Smi> tmp6;
    USE(tmp6);
    compiler::CodeAssemblerLabel label0(&ca_);
    tmp6 = Cast5ATSmi_83(state_, TNode<Object>{tmp5}, &label0);
    ca_.Goto(&block9, tmp0, tmp1, tmp2, tmp4, tmp5, tmp5, tmp6);
    if (label0.is_used()) {
      ca_.Bind(&label0);
      ca_.Goto(&block10, tmp0, tmp1, tmp2, tmp4, tmp5, tmp5);
    }
  }

  if (block10.is_used()) {
    TNode<Context> tmp7;
    TNode<Object> tmp8;
    TNode<Object> tmp9;
    TNode<String> tmp10;
    TNode<Number> tmp11;
    TNode<Number> tmp12;
    ca_.Bind(&block10, &tmp7, &tmp8, &tmp9, &tmp10, &tmp11, &tmp12);
    ca_.Goto(&block8, tmp7, tmp8, tmp9, tmp10, tmp11);
  }

  if (block9.is_used()) {
    TNode<Context> tmp13;
    TNode<Object> tmp14;
    TNode<Object> tmp15;
    TNode<String> tmp16;
    TNode<Number> tmp17;
    TNode<Number> tmp18;
    TNode<Smi> tmp19;
    ca_.Bind(&block9, &tmp13, &tmp14, &tmp15, &tmp16, &tmp17, &tmp18, &tmp19);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 41);
    TNode<Smi> tmp20;
    USE(tmp20);
    tmp20 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 0);
    TNode<BoolT> tmp21;
    USE(tmp21);
    tmp21 = CodeStubAssembler(state_).SmiLessThan(TNode<Smi>{tmp19}, TNode<Smi>{tmp20});
    ca_.Branch(tmp21, &block11, &block12, tmp13, tmp14, tmp15, tmp16, tmp17, tmp19);
  }

  if (block11.is_used()) {
    TNode<Context> tmp22;
    TNode<Object> tmp23;
    TNode<Object> tmp24;
    TNode<String> tmp25;
    TNode<Number> tmp26;
    TNode<Smi> tmp27;
    ca_.Bind(&block11, &tmp22, &tmp23, &tmp24, &tmp25, &tmp26, &tmp27);
    ca_.Goto(&block4, tmp22, tmp23, tmp24, tmp25);
  }

  if (block12.is_used()) {
    TNode<Context> tmp28;
    TNode<Object> tmp29;
    TNode<Object> tmp30;
    TNode<String> tmp31;
    TNode<Number> tmp32;
    TNode<Smi> tmp33;
    ca_.Bind(&block12, &tmp28, &tmp29, &tmp30, &tmp31, &tmp32, &tmp33);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 44);
    TNode<Smi> tmp34;
    USE(tmp34);
    tmp34 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, 0);
    TNode<BoolT> tmp35;
    USE(tmp35);
    tmp35 = CodeStubAssembler(state_).SmiEqual(TNode<Smi>{tmp33}, TNode<Smi>{tmp34});
    ca_.Branch(tmp35, &block15, &block16, tmp28, tmp29, tmp30, tmp31, tmp32, tmp33, tmp35);
  }

  if (block15.is_used()) {
    TNode<Context> tmp36;
    TNode<Object> tmp37;
    TNode<Object> tmp38;
    TNode<String> tmp39;
    TNode<Number> tmp40;
    TNode<Smi> tmp41;
    TNode<BoolT> tmp42;
    ca_.Bind(&block15, &tmp36, &tmp37, &tmp38, &tmp39, &tmp40, &tmp41, &tmp42);
    TNode<BoolT> tmp43;
    USE(tmp43);
    tmp43 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block17, tmp36, tmp37, tmp38, tmp39, tmp40, tmp41, tmp42, tmp43);
  }

  if (block16.is_used()) {
    TNode<Context> tmp44;
    TNode<Object> tmp45;
    TNode<Object> tmp46;
    TNode<String> tmp47;
    TNode<Number> tmp48;
    TNode<Smi> tmp49;
    TNode<BoolT> tmp50;
    ca_.Bind(&block16, &tmp44, &tmp45, &tmp46, &tmp47, &tmp48, &tmp49, &tmp50);
    TNode<Uint32T> tmp51;
    USE(tmp51);
    tmp51 = CodeStubAssembler(state_).LoadStringLengthAsWord32(TNode<String>{tmp47});
    TNode<Uint32T> tmp52;
    USE(tmp52);
    tmp52 = FromConstexpr8ATuint3217ATconstexpr_int31_164(state_, 0);
    TNode<BoolT> tmp53;
    USE(tmp53);
    tmp53 = CodeStubAssembler(state_).Word32Equal(TNode<Uint32T>{tmp51}, TNode<Uint32T>{tmp52});
    ca_.Goto(&block17, tmp44, tmp45, tmp46, tmp47, tmp48, tmp49, tmp50, tmp53);
  }

  if (block17.is_used()) {
    TNode<Context> tmp54;
    TNode<Object> tmp55;
    TNode<Object> tmp56;
    TNode<String> tmp57;
    TNode<Number> tmp58;
    TNode<Smi> tmp59;
    TNode<BoolT> tmp60;
    TNode<BoolT> tmp61;
    ca_.Bind(&block17, &tmp54, &tmp55, &tmp56, &tmp57, &tmp58, &tmp59, &tmp60, &tmp61);
    ca_.Branch(tmp61, &block13, &block14, tmp54, tmp55, tmp56, tmp57, tmp58, tmp59);
  }

  if (block13.is_used()) {
    TNode<Context> tmp62;
    TNode<Object> tmp63;
    TNode<Object> tmp64;
    TNode<String> tmp65;
    TNode<Number> tmp66;
    TNode<Smi> tmp67;
    ca_.Bind(&block13, &tmp62, &tmp63, &tmp64, &tmp65, &tmp66, &tmp67);
    ca_.Goto(&block6, tmp62, tmp63, tmp64, tmp65);
  }

  if (block14.is_used()) {
    TNode<Context> tmp68;
    TNode<Object> tmp69;
    TNode<Object> tmp70;
    TNode<String> tmp71;
    TNode<Number> tmp72;
    TNode<Smi> tmp73;
    ca_.Bind(&block14, &tmp68, &tmp69, &tmp70, &tmp71, &tmp72, &tmp73);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 46);
    TNode<Smi> tmp74;
    USE(tmp74);
    tmp74 = FromConstexpr5ATSmi17ATconstexpr_int31_155(state_, String::kMaxLength);
    TNode<BoolT> tmp75;
    USE(tmp75);
    tmp75 = CodeStubAssembler(state_).SmiGreaterThan(TNode<Smi>{tmp73}, TNode<Smi>{tmp74});
    ca_.Branch(tmp75, &block18, &block19, tmp68, tmp69, tmp70, tmp71, tmp72, tmp73);
  }

  if (block18.is_used()) {
    TNode<Context> tmp76;
    TNode<Object> tmp77;
    TNode<Object> tmp78;
    TNode<String> tmp79;
    TNode<Number> tmp80;
    TNode<Smi> tmp81;
    ca_.Bind(&block18, &tmp76, &tmp77, &tmp78, &tmp79, &tmp80, &tmp81);
    ca_.Goto(&block2, tmp76, tmp77, tmp78, tmp79);
  }

  if (block19.is_used()) {
    TNode<Context> tmp82;
    TNode<Object> tmp83;
    TNode<Object> tmp84;
    TNode<String> tmp85;
    TNode<Number> tmp86;
    TNode<Smi> tmp87;
    ca_.Bind(&block19, &tmp82, &tmp83, &tmp84, &tmp85, &tmp86, &tmp87);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 50);
    TNode<String> tmp88;
    tmp88 = TORQUE_CAST(CodeStubAssembler(state_).CallBuiltin(Builtins::kStringRepeat, tmp82, tmp85, tmp87));
    USE(tmp88);
    CodeStubAssembler(state_).Return(tmp88);
  }

  if (block8.is_used()) {
    TNode<Context> tmp89;
    TNode<Object> tmp90;
    TNode<Object> tmp91;
    TNode<String> tmp92;
    TNode<Number> tmp93;
    ca_.Bind(&block8, &tmp89, &tmp90, &tmp91, &tmp92, &tmp93);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 52);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 53);
    ca_.Goto(&block21, tmp89, tmp90, tmp91, tmp92, tmp93, ca_.UncheckedCast<HeapNumber>(tmp93));
  }

  if (block20.is_used()) {
    TNode<Context> tmp94;
    TNode<Object> tmp95;
    TNode<Object> tmp96;
    TNode<String> tmp97;
    TNode<Number> tmp98;
    TNode<HeapNumber> tmp99;
    ca_.Bind(&block20, &tmp94, &tmp95, &tmp96, &tmp97, &tmp98, &tmp99);
    TNode<BoolT> tmp100;
    USE(tmp100);
    tmp100 = CodeStubAssembler(state_).IsNumberNormalized(TNode<Number>{tmp99});
    ca_.Branch(tmp100, &block22, &block23, tmp94, tmp95, tmp96, tmp97, tmp98, tmp99);
  }

  if (block23.is_used()) {
    TNode<Context> tmp101;
    TNode<Object> tmp102;
    TNode<Object> tmp103;
    TNode<String> tmp104;
    TNode<Number> tmp105;
    TNode<HeapNumber> tmp106;
    ca_.Bind(&block23, &tmp101, &tmp102, &tmp103, &tmp104, &tmp105, &tmp106);
    CodeStubAssembler(state_).FailAssert("Torque assert 'IsNumberNormalized(heapNum)' failed", "../../deps/v8/src/builtins/string-repeat.tq", 53);
  }

  if (block22.is_used()) {
    TNode<Context> tmp107;
    TNode<Object> tmp108;
    TNode<Object> tmp109;
    TNode<String> tmp110;
    TNode<Number> tmp111;
    TNode<HeapNumber> tmp112;
    ca_.Bind(&block22, &tmp107, &tmp108, &tmp109, &tmp110, &tmp111, &tmp112);
  }

  if (block21.is_used()) {
    TNode<Context> tmp113;
    TNode<Object> tmp114;
    TNode<Object> tmp115;
    TNode<String> tmp116;
    TNode<Number> tmp117;
    TNode<HeapNumber> tmp118;
    ca_.Bind(&block21, &tmp113, &tmp114, &tmp115, &tmp116, &tmp117, &tmp118);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 54);
    TNode<Float64T> tmp119;
    USE(tmp119);
    tmp119 = LoadHeapNumberValue_519(state_, TNode<HeapNumber>{tmp118});
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 58);
    TNode<Float64T> tmp120;
    USE(tmp120);
    tmp120 = FromConstexpr9ATfloat6419ATconstexpr_float64_167(state_, V8_INFINITY);
    TNode<BoolT> tmp121;
    USE(tmp121);
    tmp121 = CodeStubAssembler(state_).Float64Equal(TNode<Float64T>{tmp119}, TNode<Float64T>{tmp120});
    ca_.Branch(tmp121, &block26, &block27, tmp113, tmp114, tmp115, tmp116, tmp117, tmp118, tmp119, tmp121);
  }

  if (block26.is_used()) {
    TNode<Context> tmp122;
    TNode<Object> tmp123;
    TNode<Object> tmp124;
    TNode<String> tmp125;
    TNode<Number> tmp126;
    TNode<HeapNumber> tmp127;
    TNode<Float64T> tmp128;
    TNode<BoolT> tmp129;
    ca_.Bind(&block26, &tmp122, &tmp123, &tmp124, &tmp125, &tmp126, &tmp127, &tmp128, &tmp129);
    TNode<BoolT> tmp130;
    USE(tmp130);
    tmp130 = FromConstexpr6ATbool16ATconstexpr_bool_168(state_, true);
    ca_.Goto(&block28, tmp122, tmp123, tmp124, tmp125, tmp126, tmp127, tmp128, tmp129, tmp130);
  }

  if (block27.is_used()) {
    TNode<Context> tmp131;
    TNode<Object> tmp132;
    TNode<Object> tmp133;
    TNode<String> tmp134;
    TNode<Number> tmp135;
    TNode<HeapNumber> tmp136;
    TNode<Float64T> tmp137;
    TNode<BoolT> tmp138;
    ca_.Bind(&block27, &tmp131, &tmp132, &tmp133, &tmp134, &tmp135, &tmp136, &tmp137, &tmp138);
    TNode<Float64T> tmp139;
    USE(tmp139);
    tmp139 = FromConstexpr9ATfloat6417ATconstexpr_int31_166(state_, 0.0);
    TNode<BoolT> tmp140;
    USE(tmp140);
    tmp140 = CodeStubAssembler(state_).Float64LessThan(TNode<Float64T>{tmp137}, TNode<Float64T>{tmp139});
    ca_.Goto(&block28, tmp131, tmp132, tmp133, tmp134, tmp135, tmp136, tmp137, tmp138, tmp140);
  }

  if (block28.is_used()) {
    TNode<Context> tmp141;
    TNode<Object> tmp142;
    TNode<Object> tmp143;
    TNode<String> tmp144;
    TNode<Number> tmp145;
    TNode<HeapNumber> tmp146;
    TNode<Float64T> tmp147;
    TNode<BoolT> tmp148;
    TNode<BoolT> tmp149;
    ca_.Bind(&block28, &tmp141, &tmp142, &tmp143, &tmp144, &tmp145, &tmp146, &tmp147, &tmp148, &tmp149);
    ca_.Branch(tmp149, &block24, &block25, tmp141, tmp142, tmp143, tmp144, tmp145, tmp146, tmp147);
  }

  if (block24.is_used()) {
    TNode<Context> tmp150;
    TNode<Object> tmp151;
    TNode<Object> tmp152;
    TNode<String> tmp153;
    TNode<Number> tmp154;
    TNode<HeapNumber> tmp155;
    TNode<Float64T> tmp156;
    ca_.Bind(&block24, &tmp150, &tmp151, &tmp152, &tmp153, &tmp154, &tmp155, &tmp156);
    ca_.Goto(&block4, tmp150, tmp151, tmp152, tmp153);
  }

  if (block25.is_used()) {
    TNode<Context> tmp157;
    TNode<Object> tmp158;
    TNode<Object> tmp159;
    TNode<String> tmp160;
    TNode<Number> tmp161;
    TNode<HeapNumber> tmp162;
    TNode<Float64T> tmp163;
    ca_.Bind(&block25, &tmp157, &tmp158, &tmp159, &tmp160, &tmp161, &tmp162, &tmp163);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 61);
    TNode<Uint32T> tmp164;
    USE(tmp164);
    tmp164 = CodeStubAssembler(state_).LoadStringLengthAsWord32(TNode<String>{tmp160});
    TNode<Uint32T> tmp165;
    USE(tmp165);
    tmp165 = FromConstexpr8ATuint3217ATconstexpr_int31_164(state_, 0);
    TNode<BoolT> tmp166;
    USE(tmp166);
    tmp166 = CodeStubAssembler(state_).Word32Equal(TNode<Uint32T>{tmp164}, TNode<Uint32T>{tmp165});
    ca_.Branch(tmp166, &block29, &block30, tmp157, tmp158, tmp159, tmp160, tmp161, tmp162, tmp163);
  }

  if (block29.is_used()) {
    TNode<Context> tmp167;
    TNode<Object> tmp168;
    TNode<Object> tmp169;
    TNode<String> tmp170;
    TNode<Number> tmp171;
    TNode<HeapNumber> tmp172;
    TNode<Float64T> tmp173;
    ca_.Bind(&block29, &tmp167, &tmp168, &tmp169, &tmp170, &tmp171, &tmp172, &tmp173);
    ca_.Goto(&block6, tmp167, tmp168, tmp169, tmp170);
  }

  if (block30.is_used()) {
    TNode<Context> tmp174;
    TNode<Object> tmp175;
    TNode<Object> tmp176;
    TNode<String> tmp177;
    TNode<Number> tmp178;
    TNode<HeapNumber> tmp179;
    TNode<Float64T> tmp180;
    ca_.Bind(&block30, &tmp174, &tmp175, &tmp176, &tmp177, &tmp178, &tmp179, &tmp180);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 63);
    ca_.Goto(&block2, tmp174, tmp175, tmp176, tmp177);
  }

  if (block6.is_used()) {
    TNode<Context> tmp181;
    TNode<Object> tmp182;
    TNode<Object> tmp183;
    TNode<String> tmp184;
    ca_.Bind(&block6, &tmp181, &tmp182, &tmp183, &tmp184);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 68);
    TNode<String> tmp185;
    USE(tmp185);
    tmp185 = kEmptyString_67(state_);
    CodeStubAssembler(state_).Return(tmp185);
  }

  if (block4.is_used()) {
    TNode<Context> tmp186;
    TNode<Object> tmp187;
    TNode<Object> tmp188;
    TNode<String> tmp189;
    ca_.Bind(&block4, &tmp186, &tmp187, &tmp188, &tmp189);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 71);
    CodeStubAssembler(state_).ThrowRangeError(TNode<Context>{tmp186}, MessageTemplate::kInvalidCountValue, TNode<Object>{tmp188});
  }

  if (block2.is_used()) {
    TNode<Context> tmp190;
    TNode<Object> tmp191;
    TNode<Object> tmp192;
    TNode<String> tmp193;
    ca_.Bind(&block2, &tmp190, &tmp191, &tmp192, &tmp193);
    ca_.SetSourcePosition("../../deps/v8/../../deps/v8/src/builtins/string-repeat.tq", 74);
    CodeStubAssembler(state_).CallRuntime(Runtime::kThrowInvalidStringLength, tmp190);
    CodeStubAssembler(state_).Unreachable();
  }
}

}  // namespace internal
}  // namespace v8

