class ArrayEveryLoopContinuationDescriptor : public TorqueInterfaceDescriptor<8> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayEveryLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 8> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ArrayFilterLoopContinuationDescriptor : public TorqueInterfaceDescriptor<8> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayFilterLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 8> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ArrayFindLoopContinuationDescriptor : public TorqueInterfaceDescriptor<6> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayFindLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 6> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ArrayFindIndexLoopContinuationDescriptor : public TorqueInterfaceDescriptor<6> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayFindIndexLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 6> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ArrayForEachLoopContinuationDescriptor : public TorqueInterfaceDescriptor<8> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayForEachLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 8> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class LoadJoinElement20ATDictionaryElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinElement20ATDictionaryElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinElement25ATFastSmiOrObjectElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinElement25ATFastSmiOrObjectElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinElement20ATFastDoubleElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinElement20ATFastDoubleElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class ConvertToLocaleStringDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(ConvertToLocaleStringDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class JoinStackPushDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(JoinStackPushDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class JoinStackPopDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(JoinStackPopDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class ArrayMapLoopContinuationDescriptor : public TorqueInterfaceDescriptor<7> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayMapLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 7> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ArrayReduceRightLoopContinuationDescriptor : public TorqueInterfaceDescriptor<6> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayReduceRightLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 6> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ArrayReduceLoopContinuationDescriptor : public TorqueInterfaceDescriptor<6> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayReduceLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 6> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ArraySomeLoopContinuationDescriptor : public TorqueInterfaceDescriptor<8> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArraySomeLoopContinuationDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 8> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ToStringDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(ToStringDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::AnyTagged()};
  }
};

class FastCreateDataPropertyDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(FastCreateDataPropertyDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class CheckNumberInRangeDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(CheckNumberInRangeDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class BigIntAddNoThrowDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(BigIntAddNoThrowDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class BigIntAddDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(BigIntAddDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class BigIntUnaryMinusDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(BigIntUnaryMinusDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedPointer()};
  }
};

class IncBlockCounterDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(IncBlockCounterDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class GetIteratorWithFeedbackDescriptor : public TorqueInterfaceDescriptor<4> {
  DECLARE_DESCRIPTOR_WITH_BASE(GetIteratorWithFeedbackDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 4> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::TaggedSigned(), MachineType::TaggedSigned(), MachineType::TaggedPointer()};
  }
};

class CallIteratorWithFeedbackDescriptor : public TorqueInterfaceDescriptor<4> {
  DECLARE_DESCRIPTOR_WITH_BASE(CallIteratorWithFeedbackDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 4> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::TaggedSigned(), MachineType::TaggedPointer()};
  }
};

class ProxyDeletePropertyDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxyDeletePropertyDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class ProxyGetPropertyDescriptor : public TorqueInterfaceDescriptor<4> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxyGetPropertyDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 4> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedSigned()};
  }
};

class ProxyGetPrototypeOfDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxyGetPrototypeOfDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedPointer()};
  }
};

class ProxyHasPropertyDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxyHasPropertyDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class ProxyIsExtensibleDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxyIsExtensibleDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedPointer()};
  }
};

class ProxyPreventExtensionsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxyPreventExtensionsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class ProxySetPropertyDescriptor : public TorqueInterfaceDescriptor<4> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxySetPropertyDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 4> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class ProxySetPrototypeOfDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(ProxySetPrototypeOfDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class RegExpPrototypeExecSlowDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(RegExpPrototypeExecSlowDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class RegExpMatchFastDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(RegExpMatchFastDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class RegExpReplaceDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(RegExpReplaceDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class RegExpSearchFastDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(RegExpSearchFastDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class RegExpSplitDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(RegExpSplitDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class RegExpPrototypeTestFastDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(RegExpPrototypeTestFastDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer()};
  }
};

class StringToListDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(StringToListDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedPointer()};
  }
};

class StringAddConvertLeftDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(StringAddConvertLeftDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::TaggedPointer()};
  }
};

class StringAddConvertRightDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(StringAddConvertRightDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class StringCharAtDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(StringCharAtDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineTypeOf<IntPtrT>::value};
  }
};

class CreateHTMLDescriptor : public TorqueInterfaceDescriptor<5> {
  DECLARE_DESCRIPTOR_WITH_BASE(CreateHTMLDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 5> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class StringRepeatDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(StringRepeatDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class CreateTypedArrayDescriptor : public TorqueInterfaceDescriptor<5> {
  DECLARE_DESCRIPTOR_WITH_BASE(CreateTypedArrayDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 5> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class TypedArrayMergeSortDescriptor : public TorqueInterfaceDescriptor<6> {
  DECLARE_DESCRIPTOR_WITH_BASE(TypedArrayMergeSortDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 6> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::TaggedSigned(), MachineType::TaggedPointer()};
  }
};

class Load17ATFastSmiElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Load17ATFastSmiElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class Load20ATFastObjectElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Load20ATFastObjectElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class Load20ATFastDoubleElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Load20ATFastDoubleElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class Store17ATFastSmiElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(Store17ATFastSmiElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class Store20ATFastObjectElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(Store20ATFastObjectElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class Store20ATFastDoubleElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(Store20ATFastDoubleElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class Delete17ATFastSmiElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Delete17ATFastSmiElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class Delete20ATFastObjectElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Delete20ATFastObjectElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class Delete20ATFastDoubleElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Delete20ATFastDoubleElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class SortCompareDefaultDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(SortCompareDefaultDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class SortCompareUserFnDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(SortCompareUserFnDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::AnyTagged(), MachineType::AnyTagged(), MachineType::AnyTagged()};
  }
};

class CanUseSameAccessor25ATGenericElementsAccessorDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(CanUseSameAccessor25ATGenericElementsAccessorDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class CopyDescriptor : public TorqueInterfaceDescriptor<5> {
  DECLARE_DESCRIPTOR_WITH_BASE(CopyDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 5> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::TaggedSigned()};
  }
};

class MergeAtDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(MergeAtDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class GallopLeftDescriptor : public TorqueInterfaceDescriptor<6> {
  DECLARE_DESCRIPTOR_WITH_BASE(GallopLeftDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 6> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedSigned(), MachineType::TaggedSigned(), MachineType::TaggedSigned()};
  }
};

class GallopRightDescriptor : public TorqueInterfaceDescriptor<6> {
  DECLARE_DESCRIPTOR_WITH_BASE(GallopRightDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 6> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged(), MachineType::TaggedSigned(), MachineType::TaggedSigned(), MachineType::TaggedSigned()};
  }
};

class ArrayTimSortDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(ArrayTimSortDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedPointer()};
  }
};

class GenericBuiltinTest90UT8ATBigInt7ATFalse6ATNull5ATSmi6ATTrue11ATUndefined10HeapNumber10JSReceiver6String6SymbolDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(GenericBuiltinTest90UT8ATBigInt7ATFalse6ATNull5ATSmi6ATTrue11ATUndefined10HeapNumber10JSReceiver6String6SymbolDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::AnyTagged()};
  }
};

class TestHelperPlus1Descriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(TestHelperPlus1Descriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedSigned()};
  }
};

class TestHelperPlus2Descriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(TestHelperPlus2Descriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedSigned()};
  }
};

class NewSmiBoxDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(NewSmiBoxDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedSigned()};
  }
};

class LoadJoinElement25ATGenericElementsAccessorDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinElement25ATGenericElementsAccessorDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement15ATInt32ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement15ATInt32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement17ATFloat32ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement17ATFloat32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement17ATFloat64ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement17ATFloat64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement22ATUint8ClampedElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement22ATUint8ClampedElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement19ATBigUint64ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement19ATBigUint64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement18ATBigInt64ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement18ATBigInt64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement15ATUint8ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement15ATUint8ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement14ATInt8ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement14ATInt8ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement16ATUint16ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement16ATUint16ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement15ATInt16ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement15ATInt16ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadJoinTypedElement16ATUint32ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadJoinTypedElement16ATUint32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class LoadFixedElement15ATInt32ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement15ATInt32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement17ATFloat32ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement17ATFloat32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement17ATFloat64ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement17ATFloat64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement22ATUint8ClampedElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement22ATUint8ClampedElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement19ATBigUint64ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement19ATBigUint64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement18ATBigInt64ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement18ATBigInt64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement15ATUint8ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement15ATUint8ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement14ATInt8ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement14ATInt8ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement16ATUint16ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement16ATUint16ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement15ATInt16ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement15ATInt16ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class LoadFixedElement16ATUint32ElementsDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(LoadFixedElement16ATUint32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class StoreFixedElement15ATInt32ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement15ATInt32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement17ATFloat32ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement17ATFloat32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement17ATFloat64ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement17ATFloat64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement22ATUint8ClampedElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement22ATUint8ClampedElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement19ATBigUint64ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement19ATBigUint64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement18ATBigInt64ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement18ATBigInt64ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement15ATUint8ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement15ATUint8ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement14ATInt8ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement14ATInt8ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement16ATUint16ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement16ATUint16ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement15ATInt16ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement15ATInt16ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class StoreFixedElement16ATUint32ElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(StoreFixedElement16ATUint32ElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class CanUseSameAccessor20ATFastDoubleElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(CanUseSameAccessor20ATFastDoubleElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class CanUseSameAccessor17ATFastSmiElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(CanUseSameAccessor17ATFastSmiElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class CanUseSameAccessor20ATFastObjectElementsDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(CanUseSameAccessor20ATFastObjectElementsDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedPointer();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedPointer(), MachineType::AnyTagged()};
  }
};

class Load25ATGenericElementsAccessorDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Load25ATGenericElementsAccessorDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class Store25ATGenericElementsAccessorDescriptor : public TorqueInterfaceDescriptor<3> {
  DECLARE_DESCRIPTOR_WITH_BASE(Store25ATGenericElementsAccessorDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 3> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned(), MachineType::AnyTagged()};
  }
};

class Delete25ATGenericElementsAccessorDescriptor : public TorqueInterfaceDescriptor<2> {
  DECLARE_DESCRIPTOR_WITH_BASE(Delete25ATGenericElementsAccessorDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::TaggedSigned();
  }
  std::array<MachineType, 2> ParameterTypes() override {
    return {MachineType::TaggedPointer(), MachineType::TaggedSigned()};
  }
};

class GenericBuiltinTest5ATSmiDescriptor : public TorqueInterfaceDescriptor<1> {
  DECLARE_DESCRIPTOR_WITH_BASE(GenericBuiltinTest5ATSmiDescriptor, TorqueInterfaceDescriptor)
  MachineType ReturnType() override {
    return MachineType::AnyTagged();
  }
  std::array<MachineType, 1> ParameterTypes() override {
    return {MachineType::TaggedSigned()};
  }
};

